#include <cstdio>
#include <bits/stdc++.h>
using namespace std;

const int N = 1e3 + 5;

int n, m, q;
int a[N][N];
pair<int, int> goreLevo[N][N], goreDesno[N][N], doleLevo[N][N], doleDesno[N][N];

void procesiranje()
{
    for (int j = 1; j <= m; j++)
    {
        goreLevo[0][j].first = goreDesno[0][j].first
            = doleLevo[0][j].first = doleDesno[0][j].first = INT_MAX;
        goreLevo[n+1][j].first = goreDesno[n+1][j].first
            = doleLevo[n+1][j].first = doleDesno[n+1][j].first = INT_MAX;
    }

    for (int i = 1; i <= n; i++)
    {
        goreLevo[i][0].first = goreDesno[i][0].first
            = doleLevo[i][0].first = doleDesno[i][0].first = INT_MAX;
        goreLevo[i][m+1].first = goreDesno[i][m+1].first
            = doleLevo[i][m+1].first = doleDesno[i][m+1].first = INT_MAX;
    }

    // gore
    for (int i = 1; i <= n; i++)
    {
        // gore levo
        for (int j = 1; j <= m; j++)
        {
            if (a[i][j] < goreLevo[i][j - 1].first && a[i][j] < goreLevo[i - 1][j].first)
            {
                goreLevo[i][j].first = a[i][j];
                goreLevo[i][j].second = 1;
            }
            else
            {
                int minVred, minBr;
                if (goreLevo[i][j-1].first < goreLevo[i-1][j].first)
                {
                    minVred = goreLevo[i][j-1].first;
                    minBr = goreLevo[i][j-1].second;
                }
                else if (goreLevo[i][j-1].first > goreLevo[i-1][j].first)
                {
                    minVred = goreLevo[i-1][j].first;
                    minBr = goreLevo[i-1][j].second;
                }
                else
                {
                    minVred = goreLevo[i][j-1].first;
                    minBr = goreLevo[i][j-1].second + goreLevo[i-1][j].second;

                    if (goreLevo[i-1][j-1].first == goreLevo[i][j-1].first)
                    {
                        minBr -= goreLevo[i-1][j-1].second;
                    }
                }

                if (a[i][j] == minVred)
                {
                    minBr++;
                }

                goreLevo[i][j].first = minVred;
                goreLevo[i][j].second = minBr;
            }
        }

        // gore desno
        for (int j = m; j >= 1; j--)
        {
            if (a[i][j] < goreDesno[i][j + 1].first && a[i][j] < goreDesno[i - 1][j].first)
            {
                goreDesno[i][j].first = a[i][j];
                goreDesno[i][j].second = 1;
            }
            else
            {
                int minVred, minBr;
                if (goreDesno[i][j+1].first < goreDesno[i-1][j].first)
                {
                    minVred = goreDesno[i][j+1].first;
                    minBr = goreDesno[i][j+1].second;
                }
                else if (goreDesno[i][j+1].first > goreDesno[i-1][j].first)
                {
                    minVred = goreDesno[i-1][j].first;
                    minBr = goreDesno[i-1][j].second;
                }
                else
                {
                    minVred = goreDesno[i][j+1].first;
                    minBr = goreDesno[i][j+1].second + goreDesno[i-1][j].second;

                    if (goreDesno[i-1][j+1].first == goreDesno[i][j+1].first)
                    {
                        minBr -= goreDesno[i-1][j+1].second;
                    }
                }

                if (a[i][j] == minVred)
                {
                    minBr++;
                }

                goreDesno[i][j].first = minVred;
                goreDesno[i][j].second = minBr;
            }
        }
    }

    // dole
    for (int i = n; i >= 1; i--)
    {
        // dole levo
        for (int j = 1; j <= m; j++)
        {
            if (a[i][j] < doleLevo[i][j - 1].first && a[i][j] < doleLevo[i + 1][j].first)
            {
                doleLevo[i][j].first = a[i][j];
                doleLevo[i][j].second = 1;
            }
            else
            {
                int minVred, minBr;
                if (doleLevo[i][j-1].first < doleLevo[i+1][j].first)
                {
                    minVred = doleLevo[i][j-1].first;
                    minBr = doleLevo[i][j-1].second;
                }
                else if (doleLevo[i][j-1].first > doleLevo[i+1][j].first)
                {
                    minVred = doleLevo[i+1][j].first;
                    minBr = doleLevo[i+1][j].second;
                }
                else
                {
                    minVred = doleLevo[i][j-1].first;
                    minBr = doleLevo[i][j-1].second + doleLevo[i+1][j].second;

                    if (doleLevo[i+1][j-1].first == doleLevo[i][j-1].first)
                    {
                        minBr -= doleLevo[i+1][j-1].second;
                    }
                }

                if (a[i][j] == minVred)
                {
                    minBr++;
                }

                doleLevo[i][j].first = minVred;
                doleLevo[i][j].second = minBr;
            }
        }

        // dole desno
        for (int j = m; j >= 1; j--)
        {
            if (a[i][j] < doleDesno[i][j + 1].first && a[i][j] < doleDesno[i + 1][j].first)
            {
                doleDesno[i][j].first = a[i][j];
                doleDesno[i][j].second = 1;
            }
            else
            {
                int minVred, minBr;
                if (doleDesno[i][j+1].first < doleDesno[i+1][j].first)
                {
                    minVred = doleDesno[i][j+1].first;
                    minBr = doleDesno[i][j+1].second;
                }
                else if (doleDesno[i][j+1].first > doleDesno[i+1][j].first)
                {
                    minVred = doleDesno[i+1][j].first;
                    minBr = doleDesno[i+1][j].second;
                }
                else
                {
                    minVred = doleDesno[i][j+1].first;
                    minBr = doleDesno[i][j+1].second + doleDesno[i+1][j].second;

                    if (doleDesno[i+1][j+1].first == doleDesno[i][j+1].first)
                    {
                        minBr -= doleDesno[i+1][j+1].second;
                    }
                }

                if (a[i][j] == minVred)
                {
                    minBr++;
                }

                doleDesno[i][j].first = minVred;
                doleDesno[i][j].second = minBr;
            }
        }
    }
}

int main()
{
    scanf("%d%d%d", &n, &m, &q);
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            scanf("%d", a[i] + j);
        }
    }

    procesiranje();

    while (q--)
    {
        int i, j, h, w;
        scanf("%d%d%d%d", &i, &j, &h, &w);

        int minVred = goreLevo[i+h-1][j-1].first;
        minVred = min(minVred, goreDesno[i-1][j].first);
        minVred = min(minVred, doleLevo[i+h][j+w-1].first);
        minVred = min(minVred, doleDesno[i][j+w].first);

        int br = 0;
        if (goreLevo[i+h-1][j-1].first == minVred)
        {
            br += goreLevo[i+h-1][j-1].second;
        }
        if (goreDesno[i-1][j].first == minVred)
        {
            br += goreDesno[i-1][j].second;
        }
        if (doleLevo[i+h][j+w-1].first == minVred)
        {
            br += doleLevo[i+h][j+w-1].second;
        }
        if (doleDesno[i][j+w].first == minVred)
        {
            br += doleDesno[i][j+w].second;
        }

        printf("%d\n", br);
    }

    return 0;
}