#include <iostream>
#include <vector>
#include <utility>
#include <climits>

#define MAXN 100
#define MAX2N 200
#define pii pair<int,int>

using namespace std;

int n,m,x[MAXN][MAXN],ss,n2;
vector <vector < pii > > seg_l,seg_r;
vector <vector < pii > > l,r;
//int seg_l[MAXN][MAX2N],seg_r[MAXN][MAX2N];

void in(int &q)
{
    cin>>n>>m>>q;
    for(int i=0;i<n;++i)
        for(int j=0;j<m;++j)
            cin>>x[i][j];
}

void out_x()
{
    for(int i=0;i<n;++i){
        for(int j=0;j<m;++j)
            cout<<x[i][j]<<" ";
        cout<<endl;
        }
}

void out_seg()
{
    cout<<endl;
    for(int i=0;i<seg_l.size();++i)
    {
        for(int j=0;j<seg_l[i].size();++j)
            cout<<seg_l[i][j].first<<","<<seg_l[i][j].second<<" ";
        cout<<endl;
    }
    cout<<endl;
    for(int i=0;i<seg_r.size();++i)
    {
        for(int j=0;j<seg_r[i].size();++j)
            cout<<seg_r[i][j].first<<","<<seg_r[i][j].second<<" ";
        cout<<endl;
    }
    cout<<endl<<endl;
}

void out_l_r()
{
    for(int i=0;i<l.size();++i)
    {
        for(int j=0;j<l[i].size();++j)
            cout<<l[i][j].first<<","<<l[i][j].second<<" ";
        cout<<endl;
    }
    cout<<endl;
    for(int i=0;i<r.size();++i)
    {
        for(int j=0;j<r[i].size();++j)
            cout<<r[i][j].first<<","<<r[i][j].second<<" ";
        cout<<endl;
    }
    cout<<endl<<endl;
}

void make()
{
    l.resize(n);
    for(int i=0;i<n;++i)
    {
        l[i].resize(m);
        l[i][0].first=x[i][0];
        l[i][0].second=1;
        for(int j=1;j<m;++j)
            if(x[i][j]<l[i][j-1].first)
                l[i][j].first=x[i][j], l[i][j].second=1;
            else
                if(x[i][j]==l[i][j-1].first)
                    l[i][j].first=x[i][j], l[i][j].second=l[i][j-1].second+1;
                else
                    l[i][j]=l[i][j-1];
    }
    r.resize(n);
    for(int i=0;i<n;++i)
    {
        r[i].resize(m);
        r[i][m-1].first=x[i][m-1];
        r[i][m-1].second=1;
        for(int j=m-2;j>=0;--j)
            if(x[i][j]<r[i][j+1].first)
                r[i][j].first=x[i][j], r[i][j].second=1;
            else
                if(x[i][j]==r[i][j+1].first)
                    r[i][j].first=x[i][j], r[i][j].second=r[i][j+1].second+1;
                else
                    r[i][j]=r[i][j+1];
    }
    n2=1;
    while(n2<n)
        n2*=2;
    ss=2*n2-1;
    seg_l.resize(m);
    seg_r.resize(m);
    int j;
    for(int i=0;i<m;++i)
    {
        seg_l[i].resize(ss);
        seg_r[i].resize(ss);
        for(j=n2-1;j<n2-1+n;++j)
        {
            seg_l[i][j]=l[j-(n2-1)][i];
            seg_r[i][j]=r[j-(n2-1)][i];
        }
        for(;j<ss;++j)
        {
            seg_l[i][j].first=INT_MAX;
            seg_r[i][j].first=INT_MAX;
            seg_l[i][j].second=0;
            seg_r[i][j].second=0;
        }
        for(j=n2-2;j>=0;--j)
        {
            if(seg_l[i][2*j+1].first<seg_l[i][2*j+2].first)
                seg_l[i][j]=seg_l[i][2*j+1];
            else
                if(seg_l[i][2*j+1].first==seg_l[i][2*j+2].first)
                    seg_l[i][j].first=seg_l[i][2*j+1].first, seg_l[i][j].second=seg_l[i][2*j+1].second+seg_l[i][2*j+2].second;
                else
                    seg_l[i][j]=seg_l[i][2*j+2];

            if(seg_r[i][2*j+1].first<seg_r[i][2*j+2].first)
                seg_r[i][j]=seg_r[i][2*j+1];
            else
                if(seg_r[i][2*j+1].first==seg_r[i][2*j+2].first)
                    seg_r[i][j].first=seg_r[i][2*j+1].first, seg_r[i][j].second=seg_r[i][2*j+1].second+seg_r[i][2*j+2].second;
                else
                    seg_r[i][j]=seg_r[i][2*j+2];
        }
    }
    //out_l_r();
    for(int i=0;i<l.size();++i)
        l[i].clear();
    for(int i=0;i<r.size();++i)
        r[i].clear();
    l.clear();
    r.clear();
}

pii match(pii p1,pii p2)
{
    if(p1.first>p2.first)
        return p2;
    if(p1.first<p2.first)
        return p1;
    return make_pair(p1.first,p1.second+p2.second);
}

pii min_seg(vector < pii > &seg,int l,int r,int sl,int sr,int t)
{
    if(l==sl&&r==sr)
        return seg[t];
    int middle=(sl+sr)/2;
    if(r<=middle)
        return min_seg(seg,l,r,sl,middle,2*t+1);
    if(l>middle)
        return min_seg(seg,l,r,middle+1,sr,2*t+2);
    pii p1,p2;
    p1=min_seg(seg,l,middle,sl,middle,2*t+1);
    p2=min_seg(seg,middle+1,r,middle+1,sr,2*t+2);
    return match(p1,p2);
}

pii min_seg(vector < pii > &seg,int l,int r)
{
    if(l>r)
        return make_pair(INT_MAX,0);
    r=min(r,n2-1);
    return min_seg(seg,l,r,0,n2-1,0);
}

void solve()
{
    int i1,j1,h,w,i2,j2;
    cin>>i1>>j1>>h>>w;
    --i1;
    --j1;
    i2=i1+h-1;
    j2=j1+w-1;
    pii p1,p2,p3,p4,p;
    p1=min_seg(seg_r[0],0,i1-1);
    if(j1>0)
        p2=min_seg(seg_l[j1-1],i1,i2);
    else
        p2.first=INT_MAX, p2.second=0;
    if(j2+1<m)
        p3=min_seg(seg_r[j2+1],i1,i2);
    else
        p3.first=INT_MAX, p3.second=0;
    p4=min_seg(seg_r[0],i2+1,n-1);
    /*cout<<p1.first<<" ";
    cout<<p1.second<<endl;
    cout<<p2.first<<" ";
    cout<<p2.second<<endl;
    cout<<p3.first<<" ";
    cout<<p3.second<<endl;
    cout<<p4.first<<" ";
    cout<<p4.second<<endl;*/
    p1=match(p1,p2);
    p2=match(p3,p4);
    p=match(p1,p2);
    //cout<<p.first<<" ";
    cout<<p.second<<endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);//*/
    int q;
    in(q);
    make();
    //out_seg();
    while(q--)
        solve();//*/

    return 0;
}